This sample shows how to create a tagged PDF using the Expense Analysis Report sample as a base.
The sample uses the info.title, tagged, displayTitle and lang properties to satisfy the basic Tagged PDF requirements when creating the instance of the PdfDocument class.
The sample uses the tag method to create tags and mark content and the addTag method to add tags to the logical document tree. The artifact method is used to mark decorative content as artifacts.
Note: Tagged PDF requires document version 1.4 or higher.
import 'bootstrap.css';
import '@mescius/wijmo.styles/wijmo.css';
import './styles.css';
//
import * as wijmo from '@mescius/wijmo';
import * as grid from '@mescius/wijmo.grid';
import * as chart from '@mescius/wijmo.chart';
import '@mescius/wijmo.chart.render';
import * as pdf from '@mescius/wijmo.pdf';
import * as gridPdf from '@mescius/wijmo.grid.pdf';
//
import { getEmployee } from './data';
//
document.readyState === 'complete' ? init() : window.onload = init;
//
function init() {
let employee = getEmployee();
//
let flexGrid = new grid.FlexGrid('#flexGrid', {
autoGenerateColumns: false,
headersVisibility: grid.HeadersVisibility.Column,
allowMerging: grid.AllowMerging.All,
itemsSource: employee.expenses.items,
columns: [
{ header: 'Date', binding: 'date', format: 'd', minWidth: 80 },
{ header: 'Hotel', binding: 'hotel', format: 'c' },
{ header: 'Transport', binding: 'transport', format: 'c', minWidth: 80 },
{ header: 'Meal', binding: 'meal', format: 'c' },
{ header: 'Fuel', binding: 'fuel', format: 'c' },
{ header: 'Misc', binding: 'misc', format: 'c' }
]
});
//
let flexPie = new chart.FlexPie('#flexPie', {
itemsSource: ((totals) => [
{ name: 'Hotel', value: totals.hotel },
{ name: 'Transport', value: totals.transport },
{ name: 'Meal', value: totals.meal },
{ name: 'Fuel', value: totals.fuel },
{ name: 'Misc', value: totals.misc }
])(employee.expenses.totals),
binding: 'value',
bindingName: 'name',
innerRadius: 0.75,
dataLabel: {
content: '{value:c1}',
position: chart.PieLabelPosition.Inside
}
});
//
document.querySelector('#btnExport').addEventListener('click', () => {
let doc = new pdf.PdfDocument({
info: {
title: 'Expense Analysis Report'
},
tagged: true,
displayTitle: true,
lang: 'en-US',
version: pdf.PdfVersion.v1_5,
// The header will be automatically marked as a pagination artifact.
header: {
declarative: {
text: 'Expense Analysis Report',
font: new pdf.PdfFont('times', 12),
brush: '#bfc1c2'
}
},
lineGap: 2,
pageSettings: {
margins: {
left: 12,
right: 12,
top: 12,
bottom: 12
}
},
ended: (_, args) => pdf.saveBlob(args.blob, 'FlexGrid.pdf')
});
//
drawText(doc);
//
drawEmployee(doc, flexGrid, flexPie, employee, () => {
doc.artifact(() => drawWatermark(doc), { type: pdf.PdfArtifactType.Pagination });
doc.end();
});
});
}
//
function drawText(doc) {
doc.addTag(doc.tag(pdf.PdfTagType.H1, () => {
doc.drawText('What is an expense report?', undefined, undefined, {
font: new pdf.PdfFont('times', 20, 'normal', 'bold')
});
}));
//
doc.addTag(doc.tag(pdf.PdfTagType.P, () => {
doc.drawText(`An expense report is a form of document that contains all the expenses that an
individual has incurred as a result of the business operation. For example, if the owner of a business
travels to another location for a meeting, the cost of travel, the meals, and all other expenses that
he/she has incurred may be added to the expense report.`.replace(/\n/g, ''));
}));
}
//
function drawEmployee(doc, flexGrid, flexPie, employee, done) {
let expenses = employee.expenses.items.sort((a, b) => a.date.getTime() - b.date.getTime()), minDate = expenses[0].date, maxDate = expenses[expenses.length - 1].date, bold = new pdf.PdfFont('times', 10, 'normal', 'bold');
//
doc.moveDown(2);
//
doc.addTag(doc.tag(pdf.PdfTagType.P, () => {
doc.drawText('Name: ', undefined, undefined, { font: bold, continued: true });
doc.drawText(employee.name);
}));
//
doc.addTag(doc.tag(pdf.PdfTagType.P, () => {
doc.drawText('From: ', undefined, undefined, { font: bold, continued: true });
doc.drawText(wijmo.changeType(minDate, wijmo.DataType.String, 'd'));
}));
//
doc.addTag(doc.tag(pdf.PdfTagType.P, () => {
doc.drawText('To: ', undefined, undefined, { font: bold, continued: true });
doc.drawText(wijmo.changeType(maxDate, wijmo.DataType.String, 'd'));
}));
//
doc.moveDown(2);
let y = doc.y;
//
doc.addTag(doc.tag(pdf.PdfTagType.P, () => {
doc.drawText('Expense details:', 0, y);
}));
//
gridPdf.FlexGridPdfConverter.draw(flexGrid, doc, doc.width * 0.5, null, {
styles: {
cellStyle: {
backgroundColor: '#ffffff',
borderColor: '#c6c6c6'
},
altCellStyle: {
backgroundColor: '#f9f9f9'
},
groupCellStyle: {
font: { weight: 'bold' },
backgroundColor: '#dddddd'
},
headerCellStyle: {
backgroundColor: '#eaeaea'
}
}
});
//
flexPie.saveImageToDataUrl(chart.ImageFormat.Png, (url) => {
doc.addTag(doc.tag(pdf.PdfTagType.Figure, [
doc.tag(pdf.PdfTagType.Caption, () => {
doc.drawText('Total expenses by category:', doc.width * 0.5 + 20, y);
}),
() => {
doc.drawImage(url, doc.width * 0.5 + 20, doc.y, { width: doc.width * 0.5 - 20 });
}
], { actual: 'The chart' }));
// Finish the document.
done();
});
}
//
function drawWatermark(doc) {
let docX = doc.x, docY = doc.y, font = new pdf.PdfFont('times', 120), color = wijmo.Color.fromRgba(59, 59, 109, 0.05), pgc = new wijmo.Point(doc.width / 2, doc.height / 2), text = 'Wijmo', offs = 10;
//
doc.x = 0;
doc.y = 0;
//
let sz = doc.measureText(text, font), szCx = sz.size.width / 2, szCy = sz.size.height / 2;
//
doc.saveState();
//
doc.rotate(45, pgc);
//
doc.drawText(text, pgc.x - szCx, pgc.y - szCy, {
font: font,
brush: color,
baseline: pdf.PdfTextBaseline.Top
});
//
doc.paths
.rect(pgc.x - szCx - offs, pgc.y - szCy - offs, sz.size.width + 2 * offs, sz.size.height - offs)
.stroke(new pdf.PdfPen(color, 10));
//
doc.restoreState();
//
doc.x = docX;
doc.y = docY;
}
Submit and view feedback for

<template>
<main class="container-fluid">
<!-- Export button -->
<button class="btn btn-default" @click="exportPDF">Export</button>
<div class="row">
<div class="col-lg-6 col-md-12">
<wj-flex-grid class="grid" :autoGenerateColumns=false headersVisibility="Column" allowMerging="All"
:itemsSource="employee.expenses.items" :initialized="initializeGrid">
<wj-flex-grid-column header="Date" binding="date" format="d" :minWidth=80></wj-flex-grid-column>
<wj-flex-grid-column header="Hotel" binding="hotel" format="c"></wj-flex-grid-column>
<wj-flex-grid-column header="Transport" binding="transport" format="c"
:minWidth=80></wj-flex-grid-column>
<wj-flex-grid-column header="Meal" binding="meal" format="c"></wj-flex-grid-column>
<wj-flex-grid-column header="Fuel" binding="fuel" format="c"></wj-flex-grid-column>
<wj-flex-grid-column header="Misc" binding="misc" format="c"></wj-flex-grid-column>
</wj-flex-grid>
</div>
<div class="col-lg-6 col-md-12">
<wj-flex-pie :itemsSource="totals" binding="value" bindingName="name" :innerRadius=0.75
:initialized="initializePie">
<wj-flex-pie-data-label content="{value:c1}" position="Inside"></wj-flex-pie-data-label>
</wj-flex-pie>
</div>
</div>
</main>
</template>
<script setup>
import { getEmployee } from "./data";
import * as wijmo from "@mescius/wijmo";
import * as chart from "@mescius/wijmo.chart";
import "@mescius/wijmo.chart.render";
import * as pdf from "@mescius/wijmo.pdf";
import * as gridPdf from "@mescius/wijmo.grid.pdf";
import { ref } from "vue";
const employee = ref(getEmployee());
const totals = ref(
((totals) => [
{ name: "Hotel", value: totals.hotel },
{ name: "Transport", value: totals.transport },
{ name: "Meal", value: totals.meal },
{ name: "Fuel", value: totals.fuel },
{ name: "Misc", value: totals.misc },
])(employee.value.expenses.totals),
);
const flexGrid = ref(null);
const flexPie = ref(null);
function initializeGrid(ctl) {
flexGrid.value = ctl;
}
function initializePie(ctl) {
flexPie.value = ctl;
}
function exportPDF() {
let doc = new pdf.PdfDocument({
info: {
title: "Expense Analysis Report",
},
tagged: true,
displayTitle: true,
lang: "en-US",
version: pdf.PdfVersion.v1_5,
// The header will be automatically marked as a pagination artifact.
header: {
declarative: {
text: "Expense Analysis Report",
font: new pdf.PdfFont("times", 12),
brush: "#bfc1c2",
},
},
lineGap: 2,
pageSettings: {
margins: {
left: 12,
right: 12,
top: 12,
bottom: 12,
},
},
ended: (sender, args) => pdf.saveBlob(args.blob, "FlexGrid.pdf"),
});
//
drawText(doc);
//
drawEmployee(doc, flexGrid.value, flexPie.value, employee.value, () => {
doc.artifact(() => drawWatermark(doc), { type: pdf.PdfArtifactType.Pagination });
doc.end();
});
}
function drawText(doc) {
doc.addTag(
doc.tag(pdf.PdfTagType.H1, () => {
doc.drawText("What is an expense report?", undefined, undefined, {
font: new pdf.PdfFont("times", 20, "normal", "bold"),
});
}),
);
//
doc.addTag(
doc.tag(pdf.PdfTagType.P, () => {
doc.drawText(
`An expense report is a form of document that contains all the expenses that an
individual has incurred as a result of the business operation. For example, if the owner of a business
travels to another location for a meeting, the cost of travel, the meals, and all other expenses that
he/she has incurred may be added to the expense report.`.replace(/\n/g, ""),
);
}),
);
}
function drawEmployee(doc, flexGrid, flexPie, employee, done) {
let expenses = employee.expenses.items.sort((a, b) => a.date.getTime() - b.date.getTime()),
minDate = expenses[0].date,
maxDate = expenses[expenses.length - 1].date,
bold = new pdf.PdfFont("times", 10, "normal", "bold");
//
doc.moveDown(2);
//
doc.addTag(
doc.tag(pdf.PdfTagType.P, () => {
doc.drawText("Name: ", undefined, undefined, { font: bold, continued: true });
doc.drawText(employee.name);
}),
);
//
doc.addTag(
doc.tag(pdf.PdfTagType.P, () => {
doc.drawText("From: ", undefined, undefined, { font: bold, continued: true });
doc.drawText(wijmo.changeType(minDate, wijmo.DataType.String, "d"));
}),
);
//
doc.addTag(
doc.tag(pdf.PdfTagType.P, () => {
doc.drawText("To: ", undefined, undefined, { font: bold, continued: true });
doc.drawText(wijmo.changeType(maxDate, wijmo.DataType.String, "d"));
}),
);
//
doc.moveDown(2);
let y = doc.y;
//
doc.addTag(
doc.tag(pdf.PdfTagType.P, () => {
doc.drawText("Expense details:", 0, y);
}),
);
y = doc.y;
//
gridPdf.FlexGridPdfConverter.draw(flexGrid, doc, doc.width * 0.5, null, {
styles: {
cellStyle: {
backgroundColor: "#ffffff",
borderColor: "#c6c6c6",
},
altCellStyle: {
backgroundColor: "#f9f9f9",
},
groupCellStyle: {
font: { weight: "bold" },
backgroundColor: "#dddddd",
},
headerCellStyle: {
backgroundColor: "#eaeaea",
},
},
});
//
flexPie.saveImageToDataUrl(chart.ImageFormat.Png, (url) => {
doc.addTag(
doc.tag(
pdf.PdfTagType.Figure,
[
doc.tag(pdf.PdfTagType.Caption, () => {
doc.drawText("Total expenses by category:", doc.width * 0.5 + 20, y);
}),
() => {
doc.drawImage(url, doc.width * 0.5 + 20, doc.y, { width: doc.width * 0.5 - 20 });
},
],
{ actual: "The chart" },
),
);
// Finish the document.
done();
});
}
function drawWatermark(doc) {
let docX = doc.x,
docY = doc.y,
font = new pdf.PdfFont("times", 120),
color = wijmo.Color.fromRgba(59, 59, 109, 0.05),
pgc = new wijmo.Point(doc.width / 2, doc.height / 2),
text = "Wijmo",
offs = 10;
//
doc.x = 0;
doc.y = 0;
//
let sz = doc.measureText(text, font),
szCx = sz.size.width / 2,
szCy = sz.size.height / 2;
//
doc.saveState();
//
doc.rotate(45, pgc);
//
doc.drawText(text, pgc.x - szCx, pgc.y - szCy, {
font: font,
brush: color,
baseline: pdf.PdfTextBaseline.Top,
});
//
doc.paths.rect(pgc.x - szCx - offs, pgc.y - szCy - offs, sz.size.width + 2 * offs, sz.size.height - offs).stroke(new pdf.PdfPen(color, 10));
//
doc.restoreState();
//
doc.x = docX;
doc.y = docY;
}
</script>
<style>
body {
margin-bottom: 24px;
}
.grid {
max-height: 300px;
}
.col-lg-6 {
margin: 6px 0 0 0;
}
</style>
<!DOCTYPE html>
<html lang="en">
<head>
<meta charset="utf-8">
<meta http-equiv="X-UA-Compatible" content="IE=edge">
<title>Expense analysis report</title>
<meta name="viewport" content="width=device-width, initial-scale=1.0">
<!-- SystemJS -->
<script src="compiler.js" type="module"></script>
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.5/dist/system.src.js" integrity="sha512-skZbMyvYdNoZfLmiGn5ii6KmklM82rYX2uWctBhzaXPxJgiv4XBwJnFGr5k8s+6tE1pcR1nuTKghozJHyzMcoA==" crossorigin="anonymous"></script>
<script src="systemjs.config.js"></script>
<script>
System.import('./src/app.js');
</script>
</head>
<body>
<div id="app">
</div>
</body>
</html>
export function getEmployee() {
return {
id: 'E892659',
name: 'Robert King',
department: 'Sales',
position: 'Sales Representative',
ssn: 'A37830',
manager: 'Andrew Fuller',
purpose: 'On business',
attachment: true,
advance: 1000,
expenses: getExpenses()
};
}
function getExpenses(){
// [5; 10]
let count = 5 + Math.round(Math.random() * 5),
ret = {
items: [],
totals: { hotel: 0, transport: 0, fuel: 0, meal: 0, misc: 0, total: 0 }
},
msPerDay = 1000 * 24 * 60 * 60,
curDate = Date.now() - 60 * msPerDay;
//
for (let i = 0; i < count; i++) {
let item = {
date: new Date(curDate),
description: 'Customer visit',
hotel: 30 + Math.random() * 200,
transport: 10 + Math.random() * 150,
fuel: Math.random() * 50,
meal: 30 + Math.random() * 170,
misc: Math.random() * 220,
total: 0
};
//
item.total = item.hotel + item.transport + item.fuel + item.meal + item.misc;
//
ret.totals.fuel += item.fuel;
ret.totals.hotel += item.hotel;
ret.totals.meal += item.meal;
ret.totals.misc += item.misc;
ret.totals.total += item.total;
ret.totals.transport += item.transport;
//
ret.items.push(item);
//
curDate += msPerDay * Math.round(Math.random() * 4);
}
//
return ret;
}
(function (global) {
System.config({
transpiler: 'plugin-babel',
babelOptions: {
es2015: true,
},
meta: {
'*.css': { loader: 'css' },
'*.vue': { loader: '../plugin-vue/index.js' },
//'*.vue': { loader: 'systemjs-plugin-vue' }
},
paths: {
// paths serve as alias
'npm:': 'node_modules/',
'cdn:': 'https://cdn.mescius.io/demoapps/packages/wijmojs/5.20261.50-rc/',
'pcdn:': 'https://cdn.jsdelivr.net/npm/'
},
// map tells the System loader where to look for things
map: {
'@mescius/wijmo': 'cdn:@mescius/wijmo/index.js',
'@mescius/wijmo.input': 'cdn:@mescius/wijmo.input/index.js',
'@mescius/wijmo.styles': 'cdn:@mescius/wijmo.styles',
'@mescius/wijmo.cultures': 'cdn:@mescius/wijmo.cultures',
'@mescius/wijmo.chart': 'cdn:@mescius/wijmo.chart/index.js',
'@mescius/wijmo.chart.analytics': 'cdn:@mescius/wijmo.chart.analytics/index.js',
'@mescius/wijmo.chart.animation': 'cdn:@mescius/wijmo.chart.animation/index.js',
'@mescius/wijmo.chart.annotation': 'cdn:@mescius/wijmo.chart.annotation/index.js',
'@mescius/wijmo.chart.finance': 'cdn:@mescius/wijmo.chart.finance/index.js',
'@mescius/wijmo.chart.finance.analytics': 'cdn:@mescius/wijmo.chart.finance.analytics/index.js',
'@mescius/wijmo.chart.hierarchical': 'cdn:@mescius/wijmo.chart.hierarchical/index.js',
'@mescius/wijmo.chart.interaction': 'cdn:@mescius/wijmo.chart.interaction/index.js',
'@mescius/wijmo.chart.radar': 'cdn:@mescius/wijmo.chart.radar/index.js',
'@mescius/wijmo.chart.render': 'cdn:@mescius/wijmo.chart.render/index.js',
'@mescius/wijmo.chart.webgl': 'cdn:@mescius/wijmo.chart.webgl/index.js',
'@mescius/wijmo.chart.map': 'cdn:@mescius/wijmo.chart.map/index.js',
'@mescius/wijmo.gauge': 'cdn:@mescius/wijmo.gauge/index.js',
'@mescius/wijmo.grid': 'cdn:@mescius/wijmo.grid/index.js',
'@mescius/wijmo.grid.detail': 'cdn:@mescius/wijmo.grid.detail/index.js',
'@mescius/wijmo.grid.filter': 'cdn:@mescius/wijmo.grid.filter/index.js',
'@mescius/wijmo.grid.search': 'cdn:@mescius/wijmo.grid.search/index.js',
'@mescius/wijmo.grid.style': 'cdn:@mescius/wijmo.grid.style/index.js',
'@mescius/wijmo.grid.grouppanel': 'cdn:@mescius/wijmo.grid.grouppanel/index.js',
'@mescius/wijmo.grid.multirow': 'cdn:@mescius/wijmo.grid.multirow/index.js',
'@mescius/wijmo.grid.transposed': 'cdn:@mescius/wijmo.grid.transposed/index.js',
'@mescius/wijmo.grid.transposedmultirow': 'cdn:@mescius/wijmo.grid.transposedmultirow/index.js',
'@mescius/wijmo.grid.pdf': 'cdn:@mescius/wijmo.grid.pdf/index.js',
'@mescius/wijmo.grid.sheet': 'cdn:@mescius/wijmo.grid.sheet/index.js',
'@mescius/wijmo.grid.xlsx': 'cdn:@mescius/wijmo.grid.xlsx/index.js',
'@mescius/wijmo.grid.selector': 'cdn:@mescius/wijmo.grid.selector/index.js',
'@mescius/wijmo.grid.cellmaker': 'cdn:@mescius/wijmo.grid.cellmaker/index.js',
'@mescius/wijmo.nav': 'cdn:@mescius/wijmo.nav/index.js',
'@mescius/wijmo.odata': 'cdn:@mescius/wijmo.odata/index.js',
'@mescius/wijmo.olap': 'cdn:@mescius/wijmo.olap/index.js',
'@mescius/wijmo.rest': 'cdn:@mescius/wijmo.rest/index.js',
'@mescius/wijmo.pdf': 'cdn:@mescius/wijmo.pdf/index.js',
'@mescius/wijmo.pdf.security': 'cdn:@mescius/wijmo.pdf.security/index.js',
'@mescius/wijmo.viewer': 'cdn:@mescius/wijmo.viewer/index.js',
'@mescius/wijmo.xlsx': 'cdn:@mescius/wijmo.xlsx/index.js',
'@mescius/wijmo.undo': 'cdn:@mescius/wijmo.undo/index.js',
'@mescius/wijmo.interop.grid': 'cdn:@mescius/wijmo.interop.grid/index.js',
'@mescius/wijmo.touch': 'cdn:@mescius/wijmo.touch/index.js',
'@mescius/wijmo.cloud': 'cdn:@mescius/wijmo.cloud/index.js',
'@mescius/wijmo.barcode': 'cdn:@mescius/wijmo.barcode/index.js',
'@mescius/wijmo.barcode.common': 'cdn:@mescius/wijmo.barcode.common/index.js',
'@mescius/wijmo.barcode.composite': 'cdn:@mescius/wijmo.barcode.composite/index.js',
'@mescius/wijmo.barcode.specialized': 'cdn:@mescius/wijmo.barcode.specialized/index.js',
'@mescius/wijmo.vue2.chart.analytics': 'cdn:@mescius/wijmo.vue2.chart.analytics/index.js',
'@mescius/wijmo.vue2.chart.animation': 'cdn:@mescius/wijmo.vue2.chart.animation/index.js',
'@mescius/wijmo.vue2.chart.annotation': 'cdn:@mescius/wijmo.vue2.chart.annotation/index.js',
'@mescius/wijmo.vue2.chart.finance.analytics': 'cdn:@mescius/wijmo.vue2.chart.finance.analytics/index.js',
'@mescius/wijmo.vue2.chart.finance': 'cdn:@mescius/wijmo.vue2.chart.finance/index.js',
'@mescius/wijmo.vue2.chart.hierarchical': 'cdn:@mescius/wijmo.vue2.chart.hierarchical/index.js',
'@mescius/wijmo.vue2.chart.interaction': 'cdn:@mescius/wijmo.vue2.chart.interaction/index.js',
'@mescius/wijmo.vue2.chart.radar': 'cdn:@mescius/wijmo.vue2.chart.radar/index.js',
'@mescius/wijmo.vue2.chart.map': 'cdn:@mescius/wijmo.vue2.chart.map/index.js',
'@mescius/wijmo.vue2.chart': 'cdn:@mescius/wijmo.vue2.chart/index.js',
'@mescius/wijmo.vue2.core': 'cdn:@mescius/wijmo.vue2.core/index.js',
'@mescius/wijmo.vue2.gauge': 'cdn:@mescius/wijmo.vue2.gauge/index.js',
'@mescius/wijmo.vue2.grid.detail': 'cdn:@mescius/wijmo.vue2.grid.detail/index.js',
'@mescius/wijmo.vue2.grid.filter': 'cdn:@mescius/wijmo.vue2.grid.filter/index.js',
'@mescius/wijmo.vue2.grid.grouppanel': 'cdn:@mescius/wijmo.vue2.grid.grouppanel/index.js',
'@mescius/wijmo.vue2.grid.search': 'cdn:@mescius/wijmo.vue2.grid.search/index.js',
'@mescius/wijmo.vue2.grid.multirow': 'cdn:@mescius/wijmo.vue2.grid.multirow/index.js',
'@mescius/wijmo.vue2.grid.sheet': 'cdn:@mescius/wijmo.vue2.grid.sheet/index.js',
'@mescius/wijmo.vue2.grid.transposed': 'cdn:@mescius/wijmo.vue2.grid.transposed/index.js',
'@mescius/wijmo.vue2.grid.transposedmultirow': 'cdn:@mescius/wijmo.vue2.grid.transposedmultirow/index.js',
'@mescius/wijmo.vue2.grid': 'cdn:@mescius/wijmo.vue2.grid/index.js',
'@mescius/wijmo.vue2.input': 'cdn:@mescius/wijmo.vue2.input/index.js',
'@mescius/wijmo.vue2.olap': 'cdn:@mescius/wijmo.vue2.olap/index.js',
'@mescius/wijmo.vue2.viewer': 'cdn:@mescius/wijmo.vue2.viewer/index.js',
'@mescius/wijmo.vue2.nav': 'cdn:@mescius/wijmo.vue2.nav/index.js',
'@mescius/wijmo.vue2.base': 'cdn:@mescius/wijmo.vue2.base/index.js',
'@mescius/wijmo.vue2.barcode.common': 'cdn:@mescius/wijmo.vue2.barcode.common/index.js',
'@mescius/wijmo.vue2.barcode.composite': 'cdn:@mescius/wijmo.vue2.barcode.composite/index.js',
'@mescius/wijmo.vue2.barcode.specialized': 'cdn:@mescius/wijmo.vue2.barcode.specialized/index.js',
'bootstrap.css': 'pcdn:bootstrap@3.3.7/dist/css/bootstrap.min.css',
jszip: 'pcdn:jszip@3.8.0/dist/jszip.js',
css: 'pcdn:systemjs-plugin-css@0.1.37/css.js',
vue: 'pcdn:vue@3.4.21/dist/vue.cjs.js',
'@vue/compiler-dom': 'pcdn:@vue/compiler-dom@3.4.21/dist/compiler-dom.global.prod.js',
'@vue/runtime-dom': 'pcdn:@vue/runtime-dom@3.4.21/dist/runtime-dom.global.prod.js',
'@vue/shared': 'pcdn:@vue/shared@3.4.21/dist/shared.cjs.js',
'@vue/compiler-dom': 'pcdn:@vue/compiler-dom@3.4.21/dist/compiler-dom.global.prod.js',
'@vue/runtime-dom': 'pcdn:@vue/runtime-dom@3.4.21/dist/runtime-dom.global.prod.js',
'@vue/shared': 'pcdn:@vue/shared@3.4.21/dist/shared.cjs.js',
'@vue/compiler-dom': 'pcdn:@vue/compiler-dom@3.4.21/dist/compiler-dom.global.prod.js',
'@vue/runtime-dom': 'pcdn:@vue/runtime-dom@3.4.21/dist/runtime-dom.global.prod.js',
'@vue/shared': 'pcdn:@vue/shared@3.4.21/dist/shared.cjs.js',
'@vue/compiler-dom': 'pcdn:@vue/compiler-dom@3.4.21/dist/compiler-dom.global.prod.js',
'@vue/runtime-dom': 'pcdn:@vue/runtime-dom@3.4.21/dist/runtime-dom.global.prod.js',
'@vue/shared': 'pcdn:@vue/shared@3.4.21/dist/shared.cjs.js',
'@vue/compiler-dom': 'pcdn:@vue/compiler-dom@3.4.21/dist/compiler-dom.global.prod.js',
'@vue/runtime-dom': 'pcdn:@vue/runtime-dom@3.4.21/dist/runtime-dom.global.prod.js',
'@vue/shared': 'pcdn:@vue/shared@3.4.21/dist/shared.cjs.js',
'@vue/compiler-dom': 'pcdn:@vue/compiler-dom@3.4.21/dist/compiler-dom.global.prod.js',
'@vue/runtime-dom': 'pcdn:@vue/runtime-dom@3.4.21/dist/runtime-dom.global.prod.js',
'@vue/shared': 'pcdn:@vue/shared@3.4.21/dist/shared.cjs.js',
'@vue/compiler-dom': 'pcdn:@vue/compiler-dom@3.4.21/dist/compiler-dom.global.prod.js',
'@vue/runtime-dom': 'pcdn:@vue/runtime-dom@3.4.21/dist/runtime-dom.global.prod.js',
'@vue/shared': 'pcdn:@vue/shared@3.4.21/dist/shared.cjs.js',
'@vue/compiler-dom': 'pcdn:@vue/compiler-dom@3.4.21/dist/compiler-dom.global.prod.js',
'@vue/runtime-dom': 'pcdn:@vue/runtime-dom@3.4.21/dist/runtime-dom.global.prod.js',
'@vue/shared': 'pcdn:@vue/shared@3.4.21/dist/shared.cjs.js',
'vue-loader': 'pcdn:systemjs-vue-browser@1.0.11/index.js',
//'systemjs-plugin-vue': 'pcdn:systemjs-plugin-vue@1.2.0/index.js',
'plugin-babel': 'pcdn:systemjs-plugin-babel@0.0.25/plugin-babel.js',
'systemjs-babel-build': 'pcdn:systemjs-plugin-babel@0.0.25/systemjs-babel-browser.js',
},
// packages tells the System loader how to load when no filename and/or no extension
packages: {
src: {
defaultExtension: 'js',
},
rxjs: {
defaultExtension: 'js',
},
node_modules: {
defaultExtension: 'js',
},
wijmo: {
defaultExtension: 'js',
},
},
});
})(this);

import 'bootstrap.css';
import '@mescius/wijmo.styles/wijmo.css';
import ReactDOM from 'react-dom/client';
import React, { useRef, useState } from 'react';
import useEvent from 'react-use-event-hook';
import '@mescius/wijmo.chart.render';
import * as wjcCore from '@mescius/wijmo';
import * as wjcGrid from '@mescius/wijmo.react.grid';
import * as wjChart from '@mescius/wijmo.chart';
import * as wjChartModule from '@mescius/wijmo.react.chart';
import * as gridPdf from '@mescius/wijmo.grid.pdf';
import * as pdf from '@mescius/wijmo.pdf';
import './app.css';
import { getEmployee } from './data';
function App() {
const [employee, setEmployee] = useState(getEmployee());
const [totals, setTotals] = useState([
{ name: 'Hotel', value: employee.expenses.totals.hotel },
{ name: 'Transport', value: employee.expenses.totals.transport },
{ name: 'Meal', value: employee.expenses.totals.meal },
{ name: 'Fuel', value: employee.expenses.totals.fuel },
{ name: 'Misc', value: employee.expenses.totals.misc }
]);
const flexGridRef = useRef(null);
const flexPieRef = useRef(null);
const employeeRef = useRef(null);
const initializeGrid = useEvent((ctl) => {
flexGridRef.current = ctl;
});
const initializePie = useEvent((ctl) => {
flexPieRef.current = ctl;
});
const exportPDF = () => {
let doc = new pdf.PdfDocument({
info: {
title: 'Expense Analysis Report'
},
tagged: true,
displayTitle: true,
lang: 'en-US',
version: pdf.PdfVersion.v1_5,
// The header will be automatically marked as a pagination artifact.
header: {
declarative: {
text: 'Expense Analysis Report',
font: new pdf.PdfFont('times', 12),
brush: '#bfc1c2'
}
},
lineGap: 2,
pageSettings: {
margins: {
left: 12,
right: 12,
top: 12,
bottom: 12
}
},
ended: (sender, args) => pdf.saveBlob(args.blob, 'FlexGrid.pdf')
});
drawText(doc);
drawEmployee(doc, flexGridRef.current, flexPieRef.current, employee, () => {
doc.artifact(() => drawWatermark(doc), { type: pdf.PdfArtifactType.Pagination });
doc.end();
});
};
const drawText = (doc) => {
doc.addTag(doc.tag(pdf.PdfTagType.H1, () => {
doc.drawText('What is an expense report?', undefined, undefined, {
font: new pdf.PdfFont('times', 20, 'normal', 'bold')
});
}));
//
doc.addTag(doc.tag(pdf.PdfTagType.P, () => {
doc.drawText(`An expense report is a form of document that contains all the expenses that an
individual has incurred as a result of the business operation. For example, if the owner of a business
travels to another location for a meeting, the cost of travel, the meals, and all other expenses that
he/she has incurred may be added to the expense report.`.replace(/\n/g, ''));
}));
};
const drawEmployee = (doc, flexGrid, flexPie, employee, done) => {
let expenses = employee.expenses.items.sort((a, b) => a.date.getTime() - b.date.getTime()), minDate = expenses[0].date, maxDate = expenses[expenses.length - 1].date, bold = new pdf.PdfFont('times', 10, 'normal', 'bold');
//
doc.moveDown(2);
//
doc.addTag(doc.tag(pdf.PdfTagType.P, () => {
doc.drawText('Name: ', undefined, undefined, { font: bold, continued: true });
doc.drawText(employee.name);
}));
//
doc.addTag(doc.tag(pdf.PdfTagType.P, () => {
doc.drawText('From: ', undefined, undefined, { font: bold, continued: true });
doc.drawText(wjcCore.changeType(minDate, wjcCore.DataType.String, 'd'));
}));
//
doc.addTag(doc.tag(pdf.PdfTagType.P, () => {
doc.drawText('To: ', undefined, undefined, { font: bold, continued: true });
doc.drawText(wjcCore.changeType(maxDate, wjcCore.DataType.String, 'd'));
}));
//
doc.moveDown(2);
let y = doc.y;
//
doc.addTag(doc.tag(pdf.PdfTagType.P, () => {
doc.drawText('Expense details:', 0, y);
}));
y = doc.y;
//
gridPdf.FlexGridPdfConverter.draw(flexGrid, doc, doc.width * 0.5, undefined, {
styles: {
cellStyle: {
backgroundColor: '#ffffff',
borderColor: '#c6c6c6'
},
altCellStyle: {
backgroundColor: '#f9f9f9'
},
groupCellStyle: {
font: { weight: 'bold' },
backgroundColor: '#dddddd'
},
headerCellStyle: {
backgroundColor: '#eaeaea'
}
}
});
//
flexPie.saveImageToDataUrl(wjChart.ImageFormat.Png, (url) => {
doc.addTag(doc.tag(pdf.PdfTagType.Figure, [
doc.tag(pdf.PdfTagType.Caption, () => {
doc.drawText('Total expenses by category:', doc.width * 0.5 + 20, y);
}),
() => {
doc.drawImage(url, doc.width * 0.5 + 20, doc.y, { width: doc.width * 0.5 - 20 });
}
], { actual: 'The chart' }));
// Finish the document.
done();
});
};
const drawWatermark = (doc) => {
let docX = doc.x, docY = doc.y, font = new pdf.PdfFont('times', 120), color = wjcCore.Color.fromRgba(59, 59, 109, 0.05), pgc = new wjcCore.Point(doc.width / 2, doc.height / 2), text = 'Wijmo', offs = 10;
//
doc.x = 0;
doc.y = 0;
//
let sz = doc.measureText(text, font), szCx = sz.size.width / 2, szCy = sz.size.height / 2;
//
doc.saveState();
//
doc.rotate(45, pgc);
//
doc.drawText(text, pgc.x - szCx, pgc.y - szCy, {
font: font,
brush: color,
baseline: pdf.PdfTextBaseline.Top
});
//
doc.paths
.rect(pgc.x - szCx - offs, pgc.y - szCy - offs, sz.size.width + 2 * offs, sz.size.height - offs)
.stroke(new pdf.PdfPen(color, 10));
//
doc.restoreState();
//
doc.x = docX;
doc.y = docY;
};
return (<main className="container-fluid">
{/* Export button */}
<button className="btn btn-default" onClick={exportPDF}>Export</button>
<div className="row">
<div className="col-lg-6 col-md-12">
{/* FlexGrid */}
<wjcGrid.FlexGrid className="grid" autoGenerateColumns={false} headersVisibility="Column" allowMerging="All" itemsSource={employee.expenses.items} initialized={initializeGrid}>
<wjcGrid.FlexGridColumn header="Date" binding="date" format="d" minWidth={80}/>
<wjcGrid.FlexGridColumn header="Hotel" binding="hotel" format="c"/>
<wjcGrid.FlexGridColumn header="Transport" binding="transport" format="c" minWidth={80}/>
<wjcGrid.FlexGridColumn header="Meal" binding="meal" format="c"/>
<wjcGrid.FlexGridColumn header="Fuel" binding="fuel" format="c"/>
<wjcGrid.FlexGridColumn header="Misc" binding="misc" format="c"/>
</wjcGrid.FlexGrid>
</div>
<div className="col-lg-6 col-md-12">
<wjChartModule.FlexPie binding="value" bindingName="name" innerRadius={0.75} initialized={initializePie} itemsSource={totals}>
<wjChartModule.FlexChartDataLabel content='{value:c1}'/>
</wjChartModule.FlexPie>
</div>
</div>
</main>);
}
const container = document.getElementById('app');
if (container) {
const root = ReactDOM.createRoot(container);
root.render(<App />);
}
<!DOCTYPE html>
<html lang="en">
<head>
<meta charset="utf-8">
<meta http-equiv="X-UA-Compatible" content="IE=edge">
<title>Expense analysis report</title>
<meta name="viewport" content="width=device-width, initial-scale=1.0">
<!-- SystemJS -->
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.19.40/dist/system.src.js" integrity="sha512-G6mEj6h18+m3MvzdviSDfPle/TfH0//cXcB33AKlNR/Rha0yQsKefDZKRTkIZos97HEGq2JMV1RT5ybMoQ3WsQ==" crossorigin="anonymous"></script>
<script src="systemjs.config.js"></script>
<script>
System.import('./src/app');
</script>
</head>
<body>
<div id="app"></div>
</body>
</html>
.grid {
max-height: 300px;
}
.col-lg-6 {
margin: 6px 0 0 0;
}
export function getEmployee() {
return {
id: 'E892659',
name: 'Robert King',
department: 'Sales',
position: 'Sales Representative',
ssn: 'A37830',
manager: 'Andrew Fuller',
purpose: 'On business',
attachment: true,
advance: 1000,
expenses: getExpenses()
};
}
function getExpenses() {
// [5; 10]
let count = 5 + Math.round(Math.random() * 5), ret = {
items: [],
totals: { hotel: 0, transport: 0, fuel: 0, meal: 0, misc: 0, total: 0 }
}, msPerDay = 1000 * 24 * 60 * 60, curDate = Date.now() - 60 * msPerDay;
//
for (let i = 0; i < count; i++) {
let item = {
date: new Date(curDate),
description: 'Customer visit',
hotel: 30 + Math.random() * 200,
transport: 10 + Math.random() * 150,
fuel: Math.random() * 50,
meal: 30 + Math.random() * 170,
misc: Math.random() * 220,
total: 0
};
//
item.total = item.hotel + item.transport + item.fuel + item.meal + item.misc;
//
ret.totals.fuel += item.fuel;
ret.totals.hotel += item.hotel;
ret.totals.meal += item.meal;
ret.totals.misc += item.misc;
ret.totals.total += item.total;
ret.totals.transport += item.transport;
//
ret.items.push(item);
//
curDate += msPerDay * Math.round(Math.random() * 4);
}
//
return ret;
}
(function (global) {
window.process = {
env: {
NODE_ENV: 'production',
},
};
System.config({
transpiler: 'plugin-babel',
babelOptions: {
es2015: true,
react: true,
},
meta: {
'*.css': { loader: 'css' },
},
paths: {
// paths serve as alias
'npm:': 'node_modules/',
'cdn:': 'https://cdn.mescius.io/demoapps/packages/wijmojs/5.20261.50-rc/',
'pcdn:': 'https://cdn.jsdelivr.net/npm/'
},
// map tells the System loader where to look for things
map: {
'@mescius/wijmo': 'cdn:@mescius/wijmo/index.js',
'@mescius/wijmo.input': 'cdn:@mescius/wijmo.input/index.js',
'@mescius/wijmo.styles': 'cdn:@mescius/wijmo.styles',
'@mescius/wijmo.cultures': 'cdn:@mescius/wijmo.cultures',
'@mescius/wijmo.chart': 'cdn:@mescius/wijmo.chart/index.js',
'@mescius/wijmo.chart.analytics': 'cdn:@mescius/wijmo.chart.analytics/index.js',
'@mescius/wijmo.chart.animation': 'cdn:@mescius/wijmo.chart.animation/index.js',
'@mescius/wijmo.chart.annotation': 'cdn:@mescius/wijmo.chart.annotation/index.js',
'@mescius/wijmo.chart.finance': 'cdn:@mescius/wijmo.chart.finance/index.js',
'@mescius/wijmo.chart.finance.analytics': 'cdn:@mescius/wijmo.chart.finance.analytics/index.js',
'@mescius/wijmo.chart.hierarchical': 'cdn:@mescius/wijmo.chart.hierarchical/index.js',
'@mescius/wijmo.chart.interaction': 'cdn:@mescius/wijmo.chart.interaction/index.js',
'@mescius/wijmo.chart.radar': 'cdn:@mescius/wijmo.chart.radar/index.js',
'@mescius/wijmo.chart.render': 'cdn:@mescius/wijmo.chart.render/index.js',
'@mescius/wijmo.chart.webgl': 'cdn:@mescius/wijmo.chart.webgl/index.js',
'@mescius/wijmo.chart.map': 'cdn:@mescius/wijmo.chart.map/index.js',
'@mescius/wijmo.gauge': 'cdn:@mescius/wijmo.gauge/index.js',
'@mescius/wijmo.grid': 'cdn:@mescius/wijmo.grid/index.js',
'@mescius/wijmo.grid.detail': 'cdn:@mescius/wijmo.grid.detail/index.js',
'@mescius/wijmo.grid.filter': 'cdn:@mescius/wijmo.grid.filter/index.js',
'@mescius/wijmo.grid.search': 'cdn:@mescius/wijmo.grid.search/index.js',
'@mescius/wijmo.grid.style': 'cdn:@mescius/wijmo.grid.style/index.js',
'@mescius/wijmo.grid.grouppanel': 'cdn:@mescius/wijmo.grid.grouppanel/index.js',
'@mescius/wijmo.grid.multirow': 'cdn:@mescius/wijmo.grid.multirow/index.js',
'@mescius/wijmo.grid.transposed': 'cdn:@mescius/wijmo.grid.transposed/index.js',
'@mescius/wijmo.grid.transposedmultirow': 'cdn:@mescius/wijmo.grid.transposedmultirow/index.js',
'@mescius/wijmo.grid.pdf': 'cdn:@mescius/wijmo.grid.pdf/index.js',
'@mescius/wijmo.grid.sheet': 'cdn:@mescius/wijmo.grid.sheet/index.js',
'@mescius/wijmo.grid.xlsx': 'cdn:@mescius/wijmo.grid.xlsx/index.js',
'@mescius/wijmo.grid.selector': 'cdn:@mescius/wijmo.grid.selector/index.js',
'@mescius/wijmo.grid.cellmaker': 'cdn:@mescius/wijmo.grid.cellmaker/index.js',
'@mescius/wijmo.grid.immutable': 'cdn:@mescius/wijmo.grid.immutable/index.js',
'@mescius/wijmo.touch': 'cdn:@mescius/wijmo.touch/index.js',
'@mescius/wijmo.cloud': 'cdn:@mescius/wijmo.cloud/index.js',
'@mescius/wijmo.nav': 'cdn:@mescius/wijmo.nav/index.js',
'@mescius/wijmo.odata': 'cdn:@mescius/wijmo.odata/index.js',
'@mescius/wijmo.olap': 'cdn:@mescius/wijmo.olap/index.js',
'@mescius/wijmo.rest': 'cdn:@mescius/wijmo.rest/index.js',
'@mescius/wijmo.pdf': 'cdn:@mescius/wijmo.pdf/index.js',
'@mescius/wijmo.pdf.security': 'cdn:@mescius/wijmo.pdf.security/index.js',
'@mescius/wijmo.viewer': 'cdn:@mescius/wijmo.viewer/index.js',
'@mescius/wijmo.xlsx': 'cdn:@mescius/wijmo.xlsx/index.js',
'@mescius/wijmo.undo': 'cdn:@mescius/wijmo.undo/index.js',
'@mescius/wijmo.interop.grid': 'cdn:@mescius/wijmo.interop.grid/index.js',
'@mescius/wijmo.barcode': 'cdn:@mescius/wijmo.barcode/index.js',
'@mescius/wijmo.barcode.common': 'cdn:@mescius/wijmo.barcode.common/index.js',
'@mescius/wijmo.barcode.composite': 'cdn:@mescius/wijmo.barcode.composite/index.js',
'@mescius/wijmo.barcode.specialized': 'cdn:@mescius/wijmo.barcode.specialized/index.js',
'@mescius/wijmo.react.chart.analytics': 'cdn:@mescius/wijmo.react.chart.analytics/index.js',
'@mescius/wijmo.react.chart.animation': 'cdn:@mescius/wijmo.react.chart.animation/index.js',
'@mescius/wijmo.react.chart.annotation': 'cdn:@mescius/wijmo.react.chart.annotation/index.js',
'@mescius/wijmo.react.chart.finance.analytics': 'cdn:@mescius/wijmo.react.chart.finance.analytics/index.js',
'@mescius/wijmo.react.chart.finance': 'cdn:@mescius/wijmo.react.chart.finance/index.js',
'@mescius/wijmo.react.chart.hierarchical': 'cdn:@mescius/wijmo.react.chart.hierarchical/index.js',
'@mescius/wijmo.react.chart.interaction': 'cdn:@mescius/wijmo.react.chart.interaction/index.js',
'@mescius/wijmo.react.chart.radar': 'cdn:@mescius/wijmo.react.chart.radar/index.js',
'@mescius/wijmo.react.chart': 'cdn:@mescius/wijmo.react.chart/index.js',
'@mescius/wijmo.react.core': 'cdn:@mescius/wijmo.react.core/index.js',
'@mescius/wijmo.react.chart.map': 'cdn:@mescius/wijmo.react.chart.map/index.js',
'@mescius/wijmo.react.gauge': 'cdn:@mescius/wijmo.react.gauge/index.js',
'@mescius/wijmo.react.grid.detail': 'cdn:@mescius/wijmo.react.grid.detail/index.js',
'@mescius/wijmo.react.grid.filter': 'cdn:@mescius/wijmo.react.grid.filter/index.js',
'@mescius/wijmo.react.grid.grouppanel': 'cdn:@mescius/wijmo.react.grid.grouppanel/index.js',
'@mescius/wijmo.react.grid.search': 'cdn:@mescius/wijmo.react.grid.search/index.js',
'@mescius/wijmo.react.grid.multirow': 'cdn:@mescius/wijmo.react.grid.multirow/index.js',
'@mescius/wijmo.react.grid.sheet': 'cdn:@mescius/wijmo.react.grid.sheet/index.js',
'@mescius/wijmo.react.grid.transposed': 'cdn:@mescius/wijmo.react.grid.transposed/index.js',
'@mescius/wijmo.react.grid.transposedmultirow': 'cdn:@mescius/wijmo.react.grid.transposedmultirow/index.js',
'@mescius/wijmo.react.grid.immutable': 'cdn:@mescius/wijmo.react.grid.immutable/index.js',
'@mescius/wijmo.react.grid': 'cdn:@mescius/wijmo.react.grid/index.js',
'@mescius/wijmo.react.input': 'cdn:@mescius/wijmo.react.input/index.js',
'@mescius/wijmo.react.olap': 'cdn:@mescius/wijmo.react.olap/index.js',
'@mescius/wijmo.react.viewer': 'cdn:@mescius/wijmo.react.viewer/index.js',
'@mescius/wijmo.react.nav': 'cdn:@mescius/wijmo.react.nav/index.js',
'@mescius/wijmo.react.base': 'cdn:@mescius/wijmo.react.base/index.js',
'@mescius/wijmo.react.barcode.common': 'cdn:@mescius/wijmo.react.barcode.common/index.js',
'@mescius/wijmo.react.barcode.composite': 'cdn:@mescius/wijmo.react.barcode.composite/index.js',
'@mescius/wijmo.react.barcode.specialized': 'cdn:@mescius/wijmo.react.barcode.specialized/index.js',
jszip: 'pcdn:jszip@3.8.0/dist/jszip.js',
react: 'pcdn:react@19.0.0/index.js',
'react-dom': 'pcdn:react-dom@19.0.0/index.js',
'react-dom/client': 'pcdn:react-dom@19.0.0/client.js',
scheduler: 'pcdn:scheduler@0.25.0/index.js',
redux: 'pcdn:redux@5.0.1/dist/redux.legacy-esm.js',
'react-redux': 'pcdn:react-redux@9.2.0/dist/react-redux.legacy-esm.js',
'bootstrap.css': 'pcdn:bootstrap@3.3.7/dist/css/bootstrap.min.css',
css: 'pcdn:systemjs-plugin-css@0.1.37/css.js',
'plugin-babel': 'pcdn:systemjs-plugin-babel@0.0.25/plugin-babel.js',
'systemjs-babel-build': 'pcdn:systemjs-plugin-babel@0.0.25/systemjs-babel-browser.js',
'react-use-event-hook': 'pcdn:react-use-event-hook@0.9.6/dist/esm/useEvent.js',
},
// packages tells the System loader how to load when no filename and/or no extension
packages: {
src: {
defaultExtension: 'jsx',
},
node_modules: {
defaultExtension: 'js',
},
},
});
})(this);

import 'bootstrap.css';
import '@mescius/wijmo.styles/wijmo.css';
import './styles.css';
//
import * as wijmo from '@mescius/wijmo';
import * as chart from '@mescius/wijmo.chart';
import '@mescius/wijmo.chart.render';
import * as grid from '@mescius/wijmo.grid';
import * as pdf from '@mescius/wijmo.pdf';
import * as gridPdf from '@mescius/wijmo.grid.pdf';
//
import '@angular/compiler';
import { Component, Inject, enableProdMode, ViewChild, ɵresolveComponentResources } from '@angular/core';
import { BrowserModule, bootstrapApplication } from '@angular/platform-browser';
import { DataService, IEmployee, IExpense } from './app.data';
import { WjGridModule } from '@mescius/wijmo.angular2.grid';
import { WjChartModule } from '@mescius/wijmo.angular2.chart';
//
@Component({
standalone: true,
providers: [DataService],
imports: [WjGridModule, WjChartModule, BrowserModule],
selector: 'app-component',
templateUrl: 'src/app.component.html',
})
export class AppComponent {
employee: IEmployee;
totals: any[];
@ViewChild('flexGrid', { static: true }) flexGrid: grid.FlexGrid;
@ViewChild('flexPie', { static: true }) flexPie: chart.FlexPie;
//
constructor(@Inject(DataService) private dataService: DataService) {
this.employee = dataService.getEmployee();
//
this.totals = ((totals: IExpense) => [
{ name: 'Hotel', value: totals.hotel },
{ name: 'Transport', value: totals.transport },
{ name: 'Meal', value: totals.meal },
{ name: 'Fuel', value: totals.fuel },
{ name: 'Misc', value: totals.misc },
])(this.employee.expenses.totals);
}
//
export() {
let doc = new pdf.PdfDocument({
info: {
title: 'Expense Analysis Report',
},
tagged: true,
displayTitle: true,
lang: 'en-US',
version: pdf.PdfVersion.v1_5,
// The header will be automatically marked as a pagination artifact.
header: {
declarative: {
text: 'Expense Analysis Report',
font: new pdf.PdfFont('times', 12),
brush: '#bfc1c2',
},
},
lineGap: 2,
pageSettings: {
margins: {
left: 12,
right: 12,
top: 12,
bottom: 12,
},
},
ended: (sender: pdf.PdfDocument, args: pdf.PdfDocumentEndedEventArgs) => pdf.saveBlob(args.blob, 'FlexGrid.pdf'),
});
//
this.drawText(doc);
//
this.drawEmployee(doc, this.flexGrid, this.flexPie, this.employee, () => {
doc.artifact(() => this.drawWatermark(doc), { type: pdf.PdfArtifactType.Pagination });
doc.end();
});
}
//
drawText(doc: pdf.PdfDocument) {
doc.addTag(
doc.tag(pdf.PdfTagType.H1, () => {
doc.drawText('What is an expense report?', undefined, undefined, {
font: new pdf.PdfFont('times', 20, 'normal', 'bold'),
});
}),
);
//
doc.addTag(
doc.tag(pdf.PdfTagType.P, () => {
doc.drawText(
`An expense report is a form of document that contains all the expenses that an
individual has incurred as a result of the business operation. For example, if the owner of a business
travels to another location for a meeting, the cost of travel, the meals, and all other expenses that
he/she has incurred may be added to the expense report.`.replace(/\n/g, ''),
);
}),
);
}
//
drawEmployee(
doc: pdf.PdfDocument,
flexGrid: grid.FlexGrid,
flexPie: chart.FlexPie,
employee: IEmployee,
done: Function,
) {
let expenses = employee.expenses.items.sort((a, b) => a.date.getTime() - b.date.getTime()),
minDate = expenses[0].date,
maxDate = expenses[expenses.length - 1].date,
bold = new pdf.PdfFont('times', 10, 'normal', 'bold');
//
doc.moveDown(2);
//
doc.addTag(
doc.tag(pdf.PdfTagType.P, () => {
doc.drawText('Name: ', undefined, undefined, { font: bold, continued: true });
doc.drawText(employee.name);
}),
);
//
doc.addTag(
doc.tag(pdf.PdfTagType.P, () => {
doc.drawText('From: ', undefined, undefined, { font: bold, continued: true });
doc.drawText(wijmo.changeType(minDate, wijmo.DataType.String, 'd'));
}),
);
//
doc.addTag(
doc.tag(pdf.PdfTagType.P, () => {
doc.drawText('To: ', undefined, undefined, { font: bold, continued: true });
doc.drawText(wijmo.changeType(maxDate, wijmo.DataType.String, 'd'));
}),
);
//
doc.moveDown(2);
let y = doc.y;
//
doc.addTag(
doc.tag(pdf.PdfTagType.P, () => {
doc.drawText('Expense details:', 0, y);
}),
);
y = doc.y;
//
gridPdf.FlexGridPdfConverter.draw(flexGrid, doc, doc.width * 0.5, null, {
styles: {
cellStyle: {
backgroundColor: '#ffffff',
borderColor: '#c6c6c6',
},
altCellStyle: {
backgroundColor: '#f9f9f9',
},
groupCellStyle: {
font: { weight: 'bold' },
backgroundColor: '#dddddd',
},
headerCellStyle: {
backgroundColor: '#eaeaea',
},
},
});
//
flexPie.saveImageToDataUrl(chart.ImageFormat.Png, (url: string) => {
doc.addTag(
doc.tag(
pdf.PdfTagType.Figure,
[
doc.tag(pdf.PdfTagType.Caption, () => {
doc.drawText('Total expenses by category:', doc.width * 0.5 + 20, y);
}),
() => {
doc.drawImage(url, doc.width * 0.5 + 20, doc.y, { width: doc.width * 0.5 - 20 });
},
],
{ actual: 'The chart' },
),
);
// Finish the document.
done();
});
}
//
drawWatermark(doc: pdf.PdfDocument) {
let docX = doc.x,
docY = doc.y,
font = new pdf.PdfFont('times', 120),
color = wijmo.Color.fromRgba(59, 59, 109, 0.05),
pgc = new wijmo.Point(doc.width / 2, doc.height / 2),
text = 'Wijmo',
offs = 10;
//
doc.x = 0;
doc.y = 0;
//
let sz = doc.measureText(text, font),
szCx = sz.size.width / 2,
szCy = sz.size.height / 2;
//
doc.saveState();
//
doc.rotate(45, pgc);
//
doc.drawText(text, pgc.x - szCx, pgc.y - szCy, {
font: font,
brush: color,
baseline: pdf.PdfTextBaseline.Top,
});
//
doc.paths
.rect(pgc.x - szCx - offs, pgc.y - szCy - offs, sz.size.width + 2 * offs, sz.size.height - offs)
.stroke(new pdf.PdfPen(color, 10));
//
doc.restoreState();
//
doc.x = docX;
doc.y = docY;
}
}
//
//
enableProdMode();
// Resolve resources (templateUrl, styleUrls etc), After resolution all URLs have been converted into `template` strings.
ɵresolveComponentResources(fetch).then(() => {
// Bootstrap application
bootstrapApplication(AppComponent).catch((err) => console.error(err));
});
<!DOCTYPE html>
<html lang="en">
<head>
<meta charset="utf-8">
<meta http-equiv="X-UA-Compatible" content="IE=edge">
<title>Expense analysis report</title>
<meta name="viewport" content="width=device-width, initial-scale=1.0">
<!-- Polyfills -->
<script src="https://cdn.jsdelivr.net/npm/core-js/client/shim.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/zone.js/fesm2015/zone.min.js"></script>
<!-- SystemJS -->
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.5/dist/system.src.js" integrity="sha512-skZbMyvYdNoZfLmiGn5ii6KmklM82rYX2uWctBhzaXPxJgiv4XBwJnFGr5k8s+6tE1pcR1nuTKghozJHyzMcoA==" crossorigin="anonymous"></script>
<script src="systemjs.config.js"></script>
<script>
// workaround to load 'rxjs/operators' from the rxjs bundle
System.import('rxjs').then(function (m) {
System.set(SystemJS.resolveSync('rxjs/operators'), System.newModule(m.operators));
System.import('./src/app.component');
});
</script>
</head>
<body>
<app-component></app-component>
</body>
</html>
<main class="container-fluid">
<!-- Export button -->
<button class="btn btn-default" (click)="export()">Export</button>
<div class="row">
<div class="col-lg-6 col-md-12">
<wj-flex-grid class="grid" #flexGrid [autoGenerateColumns]="false" headersVisibility="Column" allowMerging="All"
[itemsSource]="employee.expenses.items">
<wj-flex-grid-column header="Date" binding="date" format="d" [minWidth]="80"></wj-flex-grid-column>
<wj-flex-grid-column header="Hotel" binding="hotel" format="c"></wj-flex-grid-column>
<wj-flex-grid-column header="Transport" binding="transport" format="c" [minWidth]="80"></wj-flex-grid-column>
<wj-flex-grid-column header="Meal" binding="meal" format="c"></wj-flex-grid-column>
<wj-flex-grid-column header="Fuel" binding="fuel" format="c"></wj-flex-grid-column>
<wj-flex-grid-column header="Misc" binding="misc" format="c"></wj-flex-grid-column>
</wj-flex-grid>
</div>
<div class="col-lg-6 col-md-12">
<wj-flex-pie #flexPie [itemsSource]="totals" binding="value" bindingName="name" [innerRadius]="0.75">
<wj-flex-pie-data-label content="{value:c1}" position="Inside"></wj-flex-pie-data-label>
</wj-flex-pie>
</div>
</div>
</main>
import { Injectable } from '@angular/core';
//
export interface IExpense {
hotel: number;
transport: number;
fuel: number;
meal: number;
misc: number;
total: number;
}
//
export interface IExpenseDetails extends IExpense {
date: Date;
description: string;
}
//
export interface IExpenses {
items: IExpenseDetails[];
totals: IExpense;
}
//
export interface IEmployee {
id: string;
name: string;
department: string;
position: string;
ssn: string;
manager: string;
purpose: string;
attachment: boolean;
advance: number;
expenses: IExpenses;
}
//
@Injectable()
export class DataService {
getEmployee(): IEmployee {
return {
id: 'E892659',
name: 'Robert King',
department: 'Sales',
position: 'Sales Representative',
ssn: 'A37830',
manager: 'Andrew Fuller',
purpose: 'On business',
attachment: true,
advance: 1000,
expenses: this.getExpenses()
};
}
//
private getExpenses(): IExpenses {
// [5; 10]
let count = 5 + Math.round(Math.random() * 5),
ret: IExpenses = {
items: [],
totals: { hotel: 0, transport: 0, fuel: 0, meal: 0, misc: 0, total: 0 }
},
msPerDay = 1000 * 24 * 60 * 60,
curDate = Date.now() - 60 * msPerDay;
//
for (let i = 0; i < count; i++) {
let item: IExpenseDetails = {
date: new Date(curDate),
description: 'Customer visit',
hotel: 30 + Math.random() * 200,
transport: 10 + Math.random() * 150,
fuel: Math.random() * 50,
meal: 30 + Math.random() * 170,
misc: Math.random() * 220,
total: 0
};
//
item.total = item.hotel + item.transport + item.fuel + item.meal + item.misc;
//
ret.totals.fuel += item.fuel;
ret.totals.hotel += item.hotel;
ret.totals.meal += item.meal;
ret.totals.misc += item.misc;
ret.totals.total += item.total;
ret.totals.transport += item.transport;
//
ret.items.push(item);
//
curDate += msPerDay * Math.round(Math.random() * 4);
}
//
return ret;
}
}
body {
margin-bottom: 24px;
}
.grid {
max-height: 300px;
}
.col-lg-6 {
margin: 6px 0 0 0;
}
(function (global) {
SystemJS.config({
transpiler: './plugin-typescript.js',
typescriptOptions: {
target: 'ES2022',
module: 'system',
emitDecoratorMetadata: true,
experimentalDecorators: true,
},
meta: {
typescript: {
exports: 'ts',
},
'*.css': { loader: 'systemjs-plugin-css' },
'*.mjs': {
format: 'esm',
},
},
paths: {
// paths serve as alias
'npm:': 'node_modules/',
'cdn:': 'https://cdn.mescius.io/demoapps/packages/wijmojs/5.20261.50-rc/',
'pcdn:': 'https://cdn.jsdelivr.net/npm/',
'agpcdn:': 'https://cdn.jsdelivr.net/npm/'
},
packageConfigPaths: ['/node_modules/*/package.json', '/node_modules/@angular/*/package.json', '/node_modules/@mescius/*/package.json'],
map: {
'core-js': 'agpcdn:core-js@2.6.12/client/shim.min.js',
'typescript': 'agpcdn:typescript@5.9.3/lib/typescript.min.js',
rxjs: 'agpcdn:rxjs@7.8.1/dist/bundles/rxjs.umd.min.js',
'systemjs-plugin-css': 'agpcdn:systemjs-plugin-css@0.1.37/css.js',
'@mescius/wijmo': 'cdn:@mescius/wijmo/index.js',
'@mescius/wijmo.input': 'cdn:@mescius/wijmo.input/index.js',
'@mescius/wijmo.styles': 'cdn:@mescius/wijmo.styles',
'@mescius/wijmo.cultures': 'cdn:@mescius/wijmo.cultures',
'@mescius/wijmo.chart': 'cdn:@mescius/wijmo.chart/index.js',
'@mescius/wijmo.chart.analytics': 'cdn:@mescius/wijmo.chart.analytics/index.js',
'@mescius/wijmo.chart.animation': 'cdn:@mescius/wijmo.chart.animation/index.js',
'@mescius/wijmo.chart.annotation': 'cdn:@mescius/wijmo.chart.annotation/index.js',
'@mescius/wijmo.chart.finance': 'cdn:@mescius/wijmo.chart.finance/index.js',
'@mescius/wijmo.chart.finance.analytics': 'cdn:@mescius/wijmo.chart.finance.analytics/index.js',
'@mescius/wijmo.chart.hierarchical': 'cdn:@mescius/wijmo.chart.hierarchical/index.js',
'@mescius/wijmo.chart.interaction': 'cdn:@mescius/wijmo.chart.interaction/index.js',
'@mescius/wijmo.chart.radar': 'cdn:@mescius/wijmo.chart.radar/index.js',
'@mescius/wijmo.chart.render': 'cdn:@mescius/wijmo.chart.render/index.js',
'@mescius/wijmo.chart.webgl': 'cdn:@mescius/wijmo.chart.webgl/index.js',
'@mescius/wijmo.chart.map': 'cdn:@mescius/wijmo.chart.map/index.js',
'@mescius/wijmo.gauge': 'cdn:@mescius/wijmo.gauge/index.js',
'@mescius/wijmo.grid': 'cdn:@mescius/wijmo.grid/index.js',
'@mescius/wijmo.grid.detail': 'cdn:@mescius/wijmo.grid.detail/index.js',
'@mescius/wijmo.grid.filter': 'cdn:@mescius/wijmo.grid.filter/index.js',
'@mescius/wijmo.grid.search': 'cdn:@mescius/wijmo.grid.search/index.js',
'@mescius/wijmo.grid.style': 'cdn:@mescius/wijmo.grid.style/index.js',
'@mescius/wijmo.grid.grouppanel': 'cdn:@mescius/wijmo.grid.grouppanel/index.js',
'@mescius/wijmo.grid.multirow': 'cdn:@mescius/wijmo.grid.multirow/index.js',
'@mescius/wijmo.grid.transposed': 'cdn:@mescius/wijmo.grid.transposed/index.js',
'@mescius/wijmo.grid.transposedmultirow': 'cdn:@mescius/wijmo.grid.transposedmultirow/index.js',
'@mescius/wijmo.grid.pdf': 'cdn:@mescius/wijmo.grid.pdf/index.js',
'@mescius/wijmo.grid.sheet': 'cdn:@mescius/wijmo.grid.sheet/index.js',
'@mescius/wijmo.grid.xlsx': 'cdn:@mescius/wijmo.grid.xlsx/index.js',
'@mescius/wijmo.grid.selector': 'cdn:@mescius/wijmo.grid.selector/index.js',
'@mescius/wijmo.grid.cellmaker': 'cdn:@mescius/wijmo.grid.cellmaker/index.js',
'@mescius/wijmo.nav': 'cdn:@mescius/wijmo.nav/index.js',
'@mescius/wijmo.odata': 'cdn:@mescius/wijmo.odata/index.js',
'@mescius/wijmo.olap': 'cdn:@mescius/wijmo.olap/index.js',
'@mescius/wijmo.rest': 'cdn:@mescius/wijmo.rest/index.js',
'@mescius/wijmo.pdf': 'cdn:@mescius/wijmo.pdf/index.js',
'@mescius/wijmo.pdf.security': 'cdn:@mescius/wijmo.pdf.security/index.js',
'@mescius/wijmo.viewer': 'cdn:@mescius/wijmo.viewer/index.js',
'@mescius/wijmo.xlsx': 'cdn:@mescius/wijmo.xlsx/index.js',
'@mescius/wijmo.undo': 'cdn:@mescius/wijmo.undo/index.js',
'@mescius/wijmo.interop.grid': 'cdn:@mescius/wijmo.interop.grid/index.js',
'@mescius/wijmo.touch': 'cdn:@mescius/wijmo.touch/index.js',
'@mescius/wijmo.cloud': 'cdn:@mescius/wijmo.cloud/index.js',
'@mescius/wijmo.barcode': 'cdn:@mescius/wijmo.barcode/index.js',
'@mescius/wijmo.barcode.common': 'cdn:@mescius/wijmo.barcode.common/index.js',
'@mescius/wijmo.barcode.composite': 'cdn:@mescius/wijmo.barcode.composite/index.js',
'@mescius/wijmo.barcode.specialized': 'cdn:@mescius/wijmo.barcode.specialized/index.js',
'@mescius/wijmo.angular2.chart.analytics': 'cdn:@mescius/wijmo.angular2.chart.analytics/index.js',
'@mescius/wijmo.angular2.chart.animation': 'cdn:@mescius/wijmo.angular2.chart.animation/index.js',
'@mescius/wijmo.angular2.chart.annotation': 'cdn:@mescius/wijmo.angular2.chart.annotation/index.js',
'@mescius/wijmo.angular2.chart.finance.analytics': 'cdn:@mescius/wijmo.angular2.chart.finance.analytics/index.js',
'@mescius/wijmo.angular2.chart.finance': 'cdn:@mescius/wijmo.angular2.chart.finance/index.js',
'@mescius/wijmo.angular2.chart.hierarchical': 'cdn:@mescius/wijmo.angular2.chart.hierarchical/index.js',
'@mescius/wijmo.angular2.chart.interaction': 'cdn:@mescius/wijmo.angular2.chart.interaction/index.js',
'@mescius/wijmo.angular2.chart.radar': 'cdn:@mescius/wijmo.angular2.chart.radar/index.js',
'@mescius/wijmo.angular2.chart.map': 'cdn:@mescius/wijmo.angular2.chart.map/index.js',
'@mescius/wijmo.angular2.chart': 'cdn:@mescius/wijmo.angular2.chart/index.js',
'@mescius/wijmo.angular2.core': 'cdn:@mescius/wijmo.angular2.core/index.js',
'@mescius/wijmo.angular2.gauge': 'cdn:@mescius/wijmo.angular2.gauge/index.js',
'@mescius/wijmo.angular2.grid.detail': 'cdn:@mescius/wijmo.angular2.grid.detail/index.js',
'@mescius/wijmo.angular2.grid.filter': 'cdn:@mescius/wijmo.angular2.grid.filter/index.js',
'@mescius/wijmo.angular2.grid.grouppanel': 'cdn:@mescius/wijmo.angular2.grid.grouppanel/index.js',
'@mescius/wijmo.angular2.grid.search': 'cdn:@mescius/wijmo.angular2.grid.search/index.js',
'@mescius/wijmo.angular2.grid.multirow': 'cdn:@mescius/wijmo.angular2.grid.multirow/index.js',
'@mescius/wijmo.angular2.grid.sheet': 'cdn:@mescius/wijmo.angular2.grid.sheet/index.js',
'@mescius/wijmo.angular2.grid.transposed': 'cdn:@mescius/wijmo.angular2.grid.transposed/index.js',
'@mescius/wijmo.angular2.grid.transposedmultirow': 'cdn:@mescius/wijmo.angular2.grid.transposedmultirow/index.js',
'@mescius/wijmo.angular2.grid': 'cdn:@mescius/wijmo.angular2.grid/index.js',
'@mescius/wijmo.angular2.input': 'cdn:@mescius/wijmo.angular2.input/index.js',
'@mescius/wijmo.angular2.olap': 'cdn:@mescius/wijmo.angular2.olap/index.js',
'@mescius/wijmo.angular2.viewer': 'cdn:@mescius/wijmo.angular2.viewer/index.js',
'@mescius/wijmo.angular2.nav': 'cdn:@mescius/wijmo.angular2.nav/index.js',
'@mescius/wijmo.angular2.directivebase': 'cdn:@mescius/wijmo.angular2.directivebase/index.js',
'@mescius/wijmo.angular2.barcode.common': 'cdn:@mescius/wijmo.angular2.barcode.common/index.js',
'@mescius/wijmo.angular2.barcode.composite': 'cdn:@mescius/wijmo.angular2.barcode.composite/index.js',
'@mescius/wijmo.angular2.barcode.specialized': 'cdn:@mescius/wijmo.angular2.barcode.specialized/index.js',
'bootstrap.css': 'pcdn:bootstrap@3.3.7/dist/css/bootstrap.min.css',
jszip: 'agpcdn:jszip@3.10.1/dist/jszip.min.js',
'@angular/core': 'pcdn:@angular/core@21.1.0/fesm2022/core.mjs',
'@angular/core/primitives/di': 'pcdn:@angular/core@21.1.0/fesm2022/primitives-di.mjs',
'@angular/core/primitives/signals': 'pcdn:@angular/core@21.1.0/fesm2022/primitives-signals.mjs',
'@angular/core/primitives/event-dispatch': 'pcdn:@angular/core@21.1.0/fesm2022/primitives-event-dispatch.mjs',
'@angular/common': 'pcdn:@angular/common@21.1.0/fesm2022/common.mjs',
'@angular/common/http': 'pcdn:@angular/common@21.1.0/fesm2022/http.mjs',
'@angular/compiler': 'pcdn:@angular/compiler@21.1.0/fesm2022/compiler.mjs',
'@angular/platform-browser': 'pcdn:@angular/platform-browser@21.1.0/fesm2022/platform-browser.mjs',
'@angular/platform-browser-dynamic': 'pcdn:@angular/platform-browser-dynamic@21.1.0/fesm2022/platform-browser-dynamic.mjs',
'@angular/router': 'pcdn:@angular/router@21.1.0/fesm2022/router.mjs',
'@angular/forms': 'pcdn:@angular/forms@21.1.0/fesm2022/forms.mjs',
},
// packages tells the System loader how to load when no filename and/or no extension
packages: {
'./src': {
defaultExtension: 'ts',
},
node_modules: {
defaultExtension: 'js',
},
wijmo: {
defaultExtension: 'js',
},
},
});
})(this);